<script setup>
import { ref, computed, watch } from 'vue'
import axios from 'axios'
import { parseDate } from '@/utils';

const props = defineProps({
  event: Object,
  changes: Object,
  promotions: Array,
  places: Array,
  employees: Array,
  subjects: Array
})

const event = computed(() => props.event)
const changes = computed(() => props.changes)
const promotions = computed(() => props.promotions)
const places = computed(() => props.places)
const employees = computed(() => props.employees)
const subjects = computed(() => props.subjects)

const timeslotId = computed(() => {
  if (event.value === null) return
  return event.value.id
})

const startDate = computed(() => {
  if (event.value === null) return

  if (changes.value.start !== undefined) {
    return parseDate(changes.value.start)
  }
  return parseDate(event.value.start)
})

const endDate = computed(() => {
  if (event.value === null) return

  if (changes.value.end !== undefined) {
    return parseDate(changes.value.end)
  }
  return parseDate(event.value.end)
})

const selectedStartDate = ref()
watch(startDate, newVal => {
  selectedStartDate.value = newVal
})
const selectedEndDate = ref()
watch(endDate, newVal => {
  selectedEndDate.value = newVal
})

const selectedPromotions = ref([])
const selectedSubject = ref()
const selectedEmployees = ref([])
const selectedPlace = ref()

const timeslot = ref(null)
watch(timeslotId, newVal => {
  axios.get(`${import.meta.env.VITE_GESTION_EDT_API_URL}/creneaux/${newVal}`, {
    headers : {
      'Content-Type': 'application/json',
      'Accept': 'application/json'
    },
  })
    .then(response => {
      timeslot.value = response.data
      selectedPromotions.value = timeslot.value.promotionIdsDTO
      selectedSubject.value = timeslot.value.materialIdDTO
      selectedEmployees.value = timeslot.value.employeeIdsDTO
      selectedPlace.value = timeslot.value.placeIdDTO
    })
    .catch(e => {
      console.log(e)
  })
})

const infoValid = "Timeslot updated!"
const infoText = ref('')

const emit = defineEmits(['exit'])

function updateTimeslot() {

  axios.put(`${import.meta.env.VITE_GESTION_EDT_API_URL}/creneaux/`, {
    headers : {
      'Content-Type': 'application/json',
      'Accept': 'application/json'
    },
    timeslotIdDTO: timeslotId.value,
    placeIdDTO: selectedPlace.value,
    employeeIdsDTO: selectedEmployees.value,
    promotionIdsDTO: selectedPromotions.value,
    materialIdDTO: selectedSubject.value,
    startDateDTO: selectedStartDate.value,
    endDateDTO: selectedEndDate.value
  })
    .then(() => {
      infoText.value = infoValid
      setTimeout(() => {
        emit('exit')
        infoText.value = ''
      }, 2000)
    })
    .catch(e => {
      infoText.value = 'Error updating timeslot!'
  })
}
</script>

<template>
  <div class="create">
    <form class="mb-4">
      <div class="form-group">
        <label for="startDate">Start Date</label>
        <input type="datetime-local" id="startDate" class="form-control" v-model="selectedStartDate">
      </div>
      <div class="form-group">
        <label for="endDate">End Date</label>
        <input type="datetime-local" id="endDate" class="form-control" v-model="selectedEndDate">
      </div>
      <div class="form-group">
        <label for="promotion">Promotion</label>
        <div class="form-check" v-for="promotion in promotions" :key="promotion.id">
          <input type="checkbox" :id="promotion.intitule" :value="promotion.id" class="form-check-input" v-model="selectedPromotions">
          <label :for="promotion.intitule" class="form-check-label">{{ promotion.intitule }}</label>
        </div>
      </div>
      <div class="form-group">
        <label for="subject">Subject</label>
        <select id="subject" class="form-control" v-model="selectedSubject">
          <option v-for="subject in subjects" :key="subject.id" :value="subject.id">{{ subject.intitule }}</option>
        </select>
      </div>
      <div class="form-group">
        <label for="employee">Employee</label>
        <div class="form-check" v-for="employee in employees" :key="employee.id">
          <input type="checkbox" :id="employee.nom" :value="employee.id" class="form-check-input" v-model="selectedEmployees">
          <label :for="employee.nom" class="form-check-label">{{ employee.nom }} {{ employee.prenom }}</label>
        </div>
      </div>
      <div class="form-group">
        <label for="place">Place</label>
        <select id="place" class="form-control" v-model="selectedPlace">
          <option v-for="place in places" :key="place.placeIdDTO" :value="place.placeIdDTO">{{ place.roomDTO }}</option>
        </select>
      </div>
      <button type="submit" class="btn btn-primary" @click.prevent="updateTimeslot">Update</button>
      <p class="mt-3" :class="infoText === infoValid ? 'text-success' : 'text-danger'">{{ infoText }}</p>
    </form>
  </div>
</template>

<style scoped>
.form-group {
  margin-bottom: 1rem;
}
</style>